package com.winhc.task.common;

import com.alibaba.excel.annotation.ExcelProperty;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author π
 * @Description:
 * @date 2021/11/24 9:32
 */
public class Constant {
    public static final List<String> indexs = Arrays.asList("bankruptcy_open_case_respondent", "company_abnormal_info", "company_check_info", "company_court_announcement"
            , "company_court_open_announcement", "company_court_register", "company_dishonest_info", "company_double_random_check_info"
            , "company_equity_info", "company_judicial_assistance", "company_illegal_info", "company_land_mortgage_mortgagor", "company_mortgage_info",
            "company_own_tax", "company_public_announcement", "company_punishment_info_creditchina", "company_punishment_info", "company_zxr_final_case",
            "company_send_announcement", "company_tax_contravention", "company_zxr", "company_zxr_restrict", "restrictions_on_exit", "zxr_evaluate",
            "zxr_evaluate_results", "wenshu_detail_v2", "company_brief_cancel_announcement", "auction_tracking", "company_env_punishment",
            "company_liquidating_info", "company_ipr_pledge", "company_equity_pledge",
            "company_change", "company_staff", "company_holder", "company_tm", "company_finance", "company_app_info", "company_icp");

    public static final List<String> ignore_list = Arrays.asList("company_holder");

    public static List<String> PERSON_SUMMARYS = SummaryArgs.SUMMARY_ARGS.entrySet()
            .stream()
            .filter(y -> !ignore_list.contains(y.getKey()))
            .filter(x -> {
                List<String> list = x.getValue().getArgsInfo().stream().map(y -> y.filterField).distinct().collect(Collectors.toList());
                list.remove("company_id");
                return list.size() > 0;
            })
            .map(Map.Entry::getKey).collect(Collectors.toList());


    //输出表头
    public static final String company_head = "自有企业id@公司名称@公司历史名称@注册号@公司类型@注册地址@注册时间@营业时间开始日期@营业时间结束日期" +
            "@经营范围@登记机关@核准日期@企业状态@注册资本@组织机构代码@组织机构代码批准单位@机构类型@统一信用代码@省份code@市code@县区code@注册资本金额" +
            "@注册资本币种@实收资本金额@实收资本币种@公司注册状态标准化@职工参保人数@注销时间@注销原因@吊销时间@吊销原因@邮箱@电话@创建时间@是否删除@更新时间@法人信息";

    public static final String holder_head = "公司id@公司名称@股东名称@股东类型" +
            "@认缴出资额@认缴出资时间@认缴出资方式@实缴出资额@实缴出资时间@实缴出资方式" +
            "@股东的出资比例@创建时间@更新时间@是否删除";

    public static final String staff_head = "公司id@公司名称@成员名称@任职类型@创建时间@更新时间@是否删除";

    public static final String change_head = "公司标识@公司名称@变更项目对应的大类@变更事项@变更前内容@变更后内容@变更日期@创建时间@更新时间@是否删除";

    public static final String equity_info_head = "股权出质标的企业@股权出质标的企业id@省份@登记编号@出质人@出质人证照/证件号码@出质股权数额@质权人" +
            "@质权人证照/证件号码@股权出质设立登记日期@状态@公示日期@变化情况@注销日期@注销原因@出质人类型@质权人类型@创建时间@更新时间@是否删除";

    public static final String judicial_assistance_head = "冻结股权标的企业@冻结股权标的企业id@公司标识，变更信息，受让人@公司标识，变更信息，被执行人" +
            "@公司标识，续行信息，被执行人@公司标识，解除冻结信息，被执行人@公司标识，冻结信息，被执行人@被执行人id@被执行人@股权数额@执行通知书文号" +
            "@执行法院@类型|状态@冻结信息，执行法院@冻结信息，执行事项@冻结信息，执行裁定书文号@冻结信息，执行通知书文号" +
            "@冻结信息，被执行人@冻结信息，被执行人持有股权、其它投资权益的数额@冻结信息，被执行人证照种类@冻结信息，被执行人证照号码@冻结信息，冻结期限自" +
            "@冻结信息，冻结期限至@冻结信息，冻结期限@冻结信息，冻结公示日期@解除冻结信息，执行法院@解除冻结信息，执行事项@解除冻结信息，执行裁定书文号" +
            "@解除冻结信息，执行通知书文号@解除冻结信息，被执行人@解除冻结信息，被执行人持有股权、其它投资权益的数额@解除冻结信息，被执行人证照种类" +
            "@解除冻结信息，被执行人证照号码@解除冻结信息，解除冻结日期@解除冻结信息，公示日期@冻结失效信息，失效原因@冻结失效信息，失效日期" +
            "@续行信息，执行法院@续行信息，执行事项@续行信息，执行裁定书文号@续行信息，执行通知书文号@续行信息，被执行人@续行信息，被执行人持有股权、其它投资权益的数额" +
            "@续行信息，被执行人证照种类@续行信息，被执行人证照号码@续行信息，冻结期限自@续行信息，冻结期限至@续行信息，冻结期限@续行信息，冻结公示日期@变更信息，执行法院" +
            "@变更信息，执行事项@变更信息执行裁定书文号@变更信息，执行通知书文号@变更信息，被执行人@变更信息，被执行人持有股权数额@变更信息，被执行人证照种类" +
            "@变更信息，被执行人证照号码@变更信息，受让人@变更信息，协助执行日期@变更信息，受让人证照种类@变更信息，受让人证照号码@创建时间@更新时间@是否删除";

    public static final String abnormal_info_head = "公司标识@公司名字@列入异常名录原因@列入异常名录日期@决定列入异常名录部门@移除异常名录原因" +
            "@移除异常名录日期@决定移除异常名录部门@创建时间@更新时间@是否删除";

    public static final String punishment_info_head = "公司id@省份@行政处罚决定书文号@公司名称@注册号@法定代表人@法人类型@违法行为类型@行政处罚内容" +
            "@作出行政处罚决定机关名称@作出行政处罚决定日期@公示日期@描述@行政处罚决定书文件下载路径@行政处罚决定书oss文件路径@详情最后修改时间" +
            "@详情备注信息@原始链接@类型@备注信息@处理后的备注信息@创建时间@更新时间@是否删除";

    public static final String cancellation_announcement_head = "企业名称@企业ID@公告状态@统一信用代码/注册号@清算组备案信息-登记机关@清算组备案信息-清算组备案日期" +
            "@清算组备案信息-清算组成立日期@清算组备案信息-注销原因@清算组备案信息-清算组办公地址@清算组备案信息-清算组联系电话@清算组备案信息-清算组负责人" +
            "@清算组备案信息-清算组成员@债权人公告信息-统一信用代码/注册号@债权人公告信息-登记机关@债权人公告信息-公告期@债权人公告信息-公告内容" +
            "@债权人公告信息-债权申报联系人@债权人公告信息-债权申报联系电话@债权人公告信息-债权申报地址@爬取时间@数据更新时间@是否删除";

    public static final String illegal_info_head = "公司标识@公司名字@列入原因@列入日期@决定列入部门@移除原因@移除日期@决定移除部门@类别@违法事实@创建时间@更新时间@是否删除";

    public static final String check_info_head = "公司标识id@检查对象@检查实施机关@类型@日期@结果@备注@创建时间@更新时间@是否删除";

    public static final String double_random_check_info_head = "公司标识@企业名称@抽查计划编号@抽查计划名称@抽查任务编号@抽查任务名称@类型@抽查机关@抽查完成日期@创建时间@更新时间@是否删除";

    public static final String double_random_check_result_info_head = "检查事项@检查结果@创建时间@更新时间@是否删除";

    public static final String change_summary_head = "自有企业id@公司名称@注册号@统一信用代码@维度名称@发送时间@变更时间";

    public static void main(String[] args) {
        System.out.println(PERSON_SUMMARYS);
    }
}
