package com.winhc.task.job;

import com.aliyuncs.dataworks_public.model.v20180601.CreateManualDagResponse;
import com.winhc.task.bean.*;
import com.winhc.task.service.TouchService;
import com.winhc.task.util.DateUtils;
import com.winhc.task.util.SchemaInit;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.io.IOException;
import java.util.Map;

/**
 * @author π
 * @Description:
 * @date 2021/12/14 18:23
 */
@Slf4j
@Service
public class SingleSynHoloJob {

    @Autowired
    TouchService touchService;

    public void start(SummaryParam param) throws InterruptedException, IOException {
        log.info("startJob start !");
        long start = System.currentTimeMillis();
        DataWorksFlowJob dataWorksFlowJob = SchemaInit.getJobs().stream().filter(j -> j.getFlow().equals(param.getFlow())).findFirst().orElseThrow(NullPointerException::new);
        DataWorksFlowTask dataWorksFlowTask = dataWorksFlowJob.getTask().stream().filter(t -> t.getTaskName().equals(param.getTaskName())).findFirst().orElseThrow(NullPointerException::new);
        TaskParam build = TaskParam.builder()
                .projectName(dataWorksFlowJob.getProject())
                .bizDate(param.getBizdate())
                .flowName(dataWorksFlowJob.getFlow())
                .nodeParam(dataWorksFlowTask.toNodeParam(DateUtils.getYesterday()))
                .build();
        CreateManualDagResponse touch = touchService.touch(build);
        if (touch == null) {
            return;
        }
        while (true) {
            Map<String, TaskFlowEnum> query = touchService.query(dataWorksFlowJob.getProject(), touch.getReturnValue());
            long count = query.values()
                    .stream()
                    .filter(e -> !(TaskFlowEnum.SUCCESS.equals(e) || TaskFlowEnum.FAILURE.equals(e)))
                    .count();

            long count1 = query.values().stream().filter(TaskFlowEnum.FAILURE::equals).count();
            if (count1 != 0) {
                    log.error("startJob job run error : \n" + "回流job失败" + "\n!!!!!!! ");
                    //更新job运行阶段
                    return;
            }

            if (count != 0) {
                Thread.sleep(2 * 60 * 1000);
            } else {
                log.info("startJob end | cost:{} | !", (System.currentTimeMillis() - start));
                //更新job运行阶段
                return;
            }
        }
    }
}
