package com.winhc.task;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.winhc.task.bean.Company;
import com.winhc.task.bean.CompanyOut;
import com.winhc.task.common.CompanyChangeArgs;
import com.winhc.task.util.CsvToXlsxUtil;

import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

import static com.winhc.task.common.Constant.*;
import static com.winhc.task.util.CsvToXlsxUtil.jsonToXLSxNewCompany;
import static com.winhc.task.util.CsvToXlsxUtil.jsonToXLSxChange;

/**
 * @author π
 * @Description:
 * @date 2022/11/7 16:10
 */
public class TransToExcelNewCompany {


    public static void main(String[] args) {

        String ds = "20221114";
        //单个变更维度
        //toTrans(ds,"company_equity_info");
        //toTrans(ds,"company");
        //新公司
        newCompanyToExcel(ds);
        //变更
        changeToExcel(ds);

    }

    public static void changeToExcel(String ds) {
        Map<String, CompanyChangeArgs> exportArgs = CompanyChangeArgs.EXPORT_ARGS;
        exportArgs.keySet().forEach(tn -> {
            toTrans(ds, tn);
        });

    }

    private static void toTrans(String ds, String tn) {
        Map<String, CompanyChangeArgs> exportArgs = CompanyChangeArgs.EXPORT_ARGS;
        CompanyChangeArgs args = exportArgs.get(tn);
        Function<JSONObject, JSONObject> handles = args.getHandles();
        List<List<String>> company_head_list = Arrays.stream(args.getHead().split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());
        String objectName = "anshuo/dim_change/" + ds + "/" + tn + ".json";
        String outPath = "D:\\tmp\\data\\change_" + tn + ".xlsx";
        jsonToXLSxChange(tn, outPath, objectName, company_head_list, args.getClazz(),handles);
    }

    public static void newCompanyToExcel(String ds) {

        List<List<String>> company_head_list = Arrays.stream(company_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        List<List<String>> holder_head_list = Arrays.stream(holder_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        List<List<String>> staff_head_list = Arrays.stream(staff_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        String objectName = "anshuo/new_company/" + ds + "/new_company.json";
        String outPathPre = "D:\\tmp\\data\\";

        jsonToXLSxNewCompany(outPathPre, objectName, company_head_list, holder_head_list, staff_head_list);
    }
}


